searchNodes=[{"doc":"Generate CSS and JS assets for components.","ref":"Mix.Tasks.Compile.Surface.html","title":"Mix.Tasks.Compile.Surface","type":"task"},{"doc":"Converts .sface files and ~H sigils from pre-v0.5 to v0.5 syntax.mix surface.convert &quot;lib/**/*.{ex,exs,sface}&quot; &quot;test/**/*.{ex,exs}&quot;Please read the Migration Guide before running the converter and make sure you follow all required steps for a successful migration.Task-specific optionsThe Surface formatter accepts a couple of the same task-specific options as mix format. Here are some examples of using these options:$ mix surface.convert --dot-formatter path/to/.formatter.exsYou can also use the same syntax as mix format for specifying which files to convert:$ mix surface.convert path/to/file.ex &quot;lib/**/*.{ex,exs,sface}&quot; &quot;test/**/*.{ex,exs}&quot;","ref":"Mix.Tasks.Surface.Convert.html","title":"Mix.Tasks.Surface.Convert","type":"task"},{"doc":"Surface is component based library for Phoenix LiveView.Built on top of the new Phoenix.LiveComponent API, Surface provides a more declarative way to express and use components in Phoenix.Full documentation and live examples can be found at surface-ui.orgThis module defines the ~F sigil that should be used to translate Surface code into Phoenix templates.In order to have ~F available for any Phoenix view, add the following import to your web file in lib/my_app_web.ex:# lib/my_app_web.ex ... def view do quote do ... import Surface end endAdditionally, use Surface.init/1 in your mount function to initialize assigns used internally by surface:# A LiveView using surface templates defmodule PageLive do use Phoenix.LiveView import Surface def mount(_params, _session, socket) do socket = Surface.init(socket) ... {:ok, socket} end def render(assigns) do ~F&quot;&quot;&quot; ... &quot;&quot;&quot; end end # A LiveComponent using surface templates defmodule NavComponent do use Phoenix.LiveComponent import Surface def mount(socket) do socket = Surface.init(socket) ... {:ok, socket} end def render(assigns) do ~F&quot;&quot;&quot; ... &quot;&quot;&quot; end endDefining componentsTo create a component you need to define a module and use one of the available component types:Surface.Component - A stateless component.Surface.LiveComponent - A live stateful component.Surface.LiveView - A wrapper component around Phoenix.LiveView.Surface.MacroComponent - A low-level component which is responsible for translating its own content at compile time.Example# A functional stateless component defmodule Button do use Surface.Component prop click, :event prop kind, :string, default: &quot;is-info&quot; def render(assigns) do ~F&quot;&quot;&quot; &lt;button class=&quot;button {{ @kind }}&quot; phx-click={{ @click }}&gt; &lt;#slot/&gt; &lt;/button&gt; &quot;&quot;&quot; end endYou can visit the documentation of each type of component for further explanation and examples.","ref":"Surface.html","title":"Surface","type":"module"},{"doc":"Retrieve all component's config","ref":"Surface.html#get_components_config/0","title":"Surface.get_components_config/0","type":"function"},{"doc":"Retrieve the component's config based on the key","ref":"Surface.html#get_config/1","title":"Surface.get_config/1","type":"macro"},{"doc":"Retrieve a component's config based on the key","ref":"Surface.html#get_config/2","title":"Surface.get_config/2","type":"function"},{"doc":"Initialize surface state in the socket","ref":"Surface.html#init/1","title":"Surface.init/1","type":"function"},{"doc":"Converts the given code into Surface's AST.The code must be passed with the do block using the ~F sigil.Optional line and file metadata can be passed using opts.Exampleiex&gt; [tag] = ...&gt; quote_surface do ...&gt; ~F&quot;&lt;div&gt;content&lt;/div&gt;&quot; ...&gt; end ...&gt; ...&gt; tag.children [%Surface.AST.Literal{directives: [], value: &quot;content&quot;}]","ref":"Surface.html#quote_surface/2","title":"Surface.quote_surface/2","type":"macro"},{"doc":"Translates Surface code into Phoenix templates.","ref":"Surface.html#sigil_F/2","title":"Surface.sigil_F/2","type":"macro"},{"doc":"Tests if a slot has been filled in.Useful to avoid rendering unecessary html tags that are used to wrap an optional slot in combination with :if directive.Examples &lt;div :if={{ slot_assigned?(:header) }}&gt; &lt;#slot name=&quot;header&quot;/&gt; &lt;/div&gt;","ref":"Surface.html#slot_assigned?/1","title":"Surface.slot_assigned?/1","type":"macro"},{"doc":"A live stateful component. A wrapper around Phoenix.LiveComponent.Exampledefmodule Dialog do use Surface.LiveComponent prop title, :string, required: true def mount(socket) do {:ok, assign(socket, show: false)} end def render(assigns) do ~F&quot;&quot;&quot; &lt;div class={{ &quot;modal&quot;, &quot;is-active&quot;: @show }}&gt; &lt;div class=&quot;modal-background&quot;&gt;&lt;/div&gt; &lt;div class=&quot;modal-card&quot;&gt; &lt;header class=&quot;modal-card-head&quot;&gt; &lt;p class=&quot;modal-card-title&quot;&gt;{{ @title }}&lt;/p&gt; &lt;/header&gt; &lt;section class=&quot;modal-card-body&quot;&gt; &lt;#slot/&gt; &lt;/section&gt; &lt;footer class=&quot;modal-card-foot&quot; style=&quot;justify-content: flex-end&quot;&gt; &lt;Button click=&quot;hide&quot;&gt;Ok&lt;/Button&gt; &lt;/footer&gt; &lt;/div&gt; &lt;/div&gt; &quot;&quot;&quot; end # Public API def show(dialog_id) do send_update(__MODULE__, id: dialog_id, show: true) end # Event handlers def handle_event(&quot;show&quot;, _, socket) do {:noreply, assign(socket, show: true)} end def handle_event(&quot;hide&quot;, _, socket) do {:noreply, assign(socket, show: false)} end end","ref":"Surface.LiveComponent.html","title":"Surface.LiveComponent","type":"module"},{"doc":"A wrapper component around Phoenix.LiveView.Since this module is just a wrapper around Phoenix.LiveView, you cannot define custom properties for it. Only :id and :session are available. However, built-in directives like :for and :if can be used normally.Exampledefmodule Example do use Surface.LiveView def render(assigns) do ~F&quot;&quot;&quot; &lt;Dialog title=&quot;Alert&quot; id=&quot;dialog&quot;&gt; This &lt;b&gt;Dialog&lt;/b&gt; is a stateful component. Cool! &lt;/Dialog&gt; &lt;Button click=&quot;show_dialog&quot;&gt;Click to open the dialog&lt;/Button&gt; &quot;&quot;&quot; end def handle_event(&quot;show_dialog&quot;, _, socket) do Dialog.show(&quot;dialog&quot;) {:noreply, socket} end end","ref":"Surface.LiveView.html","title":"Surface.LiveView","type":"module"},{"doc":"Conveniences for testing Surface components.","ref":"Surface.LiveViewTest.html","title":"Surface.LiveViewTest","type":"module"},{"doc":"Compiles Surface code into a new LiveView module.This macro should be used sparingly as it always generates and compiles a new module on-the-fly, which can potentially slow down your test suite.Its main use is when testing compile-time errors/warnings.Examplecode = quote do ~F&quot;&quot;&quot; &lt;KeywordProp prop=&quot;some string&quot;/&gt; &quot;&quot;&quot; end message = ~S(code:1: invalid value for property &quot;prop&quot;. Expected a :keyword, got: &quot;some string&quot;.) assert_raise(CompileError, message, fn -&gt; compile_surface(code) end)","ref":"Surface.LiveViewTest.html#compile_surface/2","title":"Surface.LiveViewTest.compile_surface/2","type":"macro"},{"doc":"Render Surface code.Use this macro when testing regular rendering of stateless components or live components that don't require a parent live view during the tests.For tests depending on the existence of a parent live view, e.g. testing events on live components and its side-effects, you need to use either Phoenix.LiveViewTest.live/2 or Phoenix.LiveViewTest.live_isolated/3.Examplehtml = render_surface do ~F&quot;&quot;&quot; &lt;Link label=&quot;user&quot; to=&quot;/users/1&quot; /&gt; &quot;&quot;&quot; end assert html =~ &quot;&quot;&quot; &lt;a href=&quot;/users/1&quot;&gt;user&lt;/a&gt; &quot;&quot;&quot;","ref":"Surface.LiveViewTest.html#render_surface/1","title":"Surface.LiveViewTest.render_surface/1","type":"macro"},{"doc":"Wraps a test code so it runs using a custom configuration for a given component.Tests using this macro should run synchronously. A warning is shown if the test case is configured as async: true.Exampleusing_config TextInput, default_class: &quot;default_class&quot; do html = render_surface do ~F&quot;&quot;&quot; &lt;TextInput/&gt; &quot;&quot;&quot; end assert html =~ ~r/class=&quot;default_class&quot;/ end","ref":"Surface.LiveViewTest.html#using_config/3","title":"Surface.LiveViewTest.using_config/3","type":"macro"},{"doc":"A low-level component which is responsible for translating its own content at compile time.","ref":"Surface.MacroComponent.html","title":"Surface.MacroComponent","type":"behaviour"},{"doc":"Evaluates the values of the static properties of a macro component.Usually called inside translate/2 in order to retrieve the properties' values at compile-time.","ref":"Surface.MacroComponent.html#eval_static_props!/3","title":"Surface.MacroComponent.eval_static_props!/3","type":"function"},{"doc":"This function is called to expand a macro component into a set of Surface.AST nodes.","ref":"Surface.MacroComponent.html#c:expand/3","title":"Surface.MacroComponent.expand/3","type":"callback"},{"doc":"Defines a behaviour that must be implemented by all HTML/Surface node translators.This module also contains the main logic to translate Surface code.","ref":"Surface.Compiler.html","title":"Surface.Compiler","type":"module"},{"doc":"This function compiles a string into the Surface AST.This is used by ~F and Surface.Renderer to parse and compile templates.A special note for line: This is considered the line number for the first line in the string. If the first line of the string is also the first line of the file, then this should be 1. If this is being called within a macro (say to process a heredoc passed to ~F), this should be CALLER.line + 1.","ref":"Surface.Compiler.html#compile/5","title":"Surface.Compiler.compile/5","type":"function"},{"doc":"","ref":"Surface.Compiler.html#to_ast/2","title":"Surface.Compiler.to_ast/2","type":"function"},{"doc":"","ref":"Surface.Compiler.html#to_live_struct/2","title":"Surface.Compiler.to_live_struct/2","type":"function"},{"doc":"","ref":"Surface.Compiler.html#validate_component_structure/3","title":"Surface.Compiler.validate_component_structure/3","type":"function"},{"doc":"","ref":"Surface.Compiler.CompileMeta.html","title":"Surface.Compiler.CompileMeta","type":"module"},{"doc":"","ref":"Surface.Compiler.CompileMeta.html#t:t/0","title":"Surface.Compiler.CompileMeta.t/0","type":"type"},{"doc":"This module glues together surface's AST and Phoenix.LiveView.Engine to actually render an AST.It takes a list of Surface AST nodes, and processes them into a sequence of static raw html items and dynamic pieces. It then converts these into tokens which an EEx engine can understand (see EEx.Tokenizer for information on this). Finally, it passes these tokens into the engine sequentially in the same manner as EEx.Compiler.compile/2","ref":"Surface.Compiler.EExEngine.html","title":"Surface.Compiler.EExEngine","type":"module"},{"doc":"","ref":"Surface.Compiler.EExEngine.html#translate/2","title":"Surface.Compiler.EExEngine.translate/2","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html","title":"Surface.Compiler.Helpers","type":"module"},{"doc":"","ref":"Surface.Compiler.Helpers.html#actual_component_module!/2","title":"Surface.Compiler.Helpers.actual_component_module!/2","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#blank?/1","title":"Surface.Compiler.Helpers.blank?/1","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#builtin_assigns_by_type/1","title":"Surface.Compiler.Helpers.builtin_assigns_by_type/1","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#check_module_is_component/1","title":"Surface.Compiler.Helpers.check_module_is_component/1","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#check_module_loaded/2","title":"Surface.Compiler.Helpers.check_module_loaded/2","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#did_you_mean/2","title":"Surface.Compiler.Helpers.did_you_mean/2","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#expression_to_quoted!/2","title":"Surface.Compiler.Helpers.expression_to_quoted!/2","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#is_blank_or_empty/1","title":"Surface.Compiler.Helpers.is_blank_or_empty/1","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#list_to_string/3","title":"Surface.Compiler.Helpers.list_to_string/3","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#perform_assigns_checks/2","title":"Surface.Compiler.Helpers.perform_assigns_checks/2","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#position_to_line/1","title":"Surface.Compiler.Helpers.position_to_line/1","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#to_meta/2","title":"Surface.Compiler.Helpers.to_meta/2","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#used_assigns/1","title":"Surface.Compiler.Helpers.used_assigns/1","type":"function"},{"doc":"","ref":"Surface.Compiler.Helpers.html#validate_component_module/2","title":"Surface.Compiler.Helpers.validate_component_module/2","type":"function"},{"doc":"","ref":"Surface.Compiler.ParseError.html","title":"Surface.Compiler.ParseError","type":"exception"},{"doc":"","ref":"Surface.Compiler.ParseTreeTranslator.html","title":"Surface.Compiler.ParseTreeTranslator","type":"module"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.context_for_block/3.","ref":"Surface.Compiler.ParseTreeTranslator.html#context_for_block/3","title":"Surface.Compiler.ParseTreeTranslator.context_for_block/3","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.context_for_node/3.","ref":"Surface.Compiler.ParseTreeTranslator.html#context_for_node/3","title":"Surface.Compiler.ParseTreeTranslator.context_for_node/3","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.context_for_subblock/4.","ref":"Surface.Compiler.ParseTreeTranslator.html#context_for_subblock/4","title":"Surface.Compiler.ParseTreeTranslator.context_for_subblock/4","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_attribute/5.","ref":"Surface.Compiler.ParseTreeTranslator.html#handle_attribute/5","title":"Surface.Compiler.ParseTreeTranslator.handle_attribute/5","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_block/6.","ref":"Surface.Compiler.ParseTreeTranslator.html#handle_block/6","title":"Surface.Compiler.ParseTreeTranslator.handle_block/6","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_block_expression/4.","ref":"Surface.Compiler.ParseTreeTranslator.html#handle_block_expression/4","title":"Surface.Compiler.ParseTreeTranslator.handle_block_expression/4","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_comment/3.","ref":"Surface.Compiler.ParseTreeTranslator.html#handle_comment/3","title":"Surface.Compiler.ParseTreeTranslator.handle_comment/3","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_expression/3.","ref":"Surface.Compiler.ParseTreeTranslator.html#handle_expression/3","title":"Surface.Compiler.ParseTreeTranslator.handle_expression/3","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_init/1.","ref":"Surface.Compiler.ParseTreeTranslator.html#handle_init/1","title":"Surface.Compiler.ParseTreeTranslator.handle_init/1","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_node/6.","ref":"Surface.Compiler.ParseTreeTranslator.html#handle_node/6","title":"Surface.Compiler.ParseTreeTranslator.handle_node/6","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_subblock/6.","ref":"Surface.Compiler.ParseTreeTranslator.html#handle_subblock/6","title":"Surface.Compiler.ParseTreeTranslator.handle_subblock/6","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_tagged_expression/4.","ref":"Surface.Compiler.ParseTreeTranslator.html#handle_tagged_expression/4","title":"Surface.Compiler.ParseTreeTranslator.handle_tagged_expression/4","type":"function"},{"doc":"Callback implementation for c:Surface.Compiler.NodeTranslator.handle_text/2.","ref":"Surface.Compiler.ParseTreeTranslator.html#handle_text/2","title":"Surface.Compiler.ParseTreeTranslator.handle_text/2","type":"function"},{"doc":"","ref":"Surface.Compiler.ParseTreeTranslator.html#to_meta/1","title":"Surface.Compiler.ParseTreeTranslator.to_meta/1","type":"function"},{"doc":"Defines a stateless component.Exampledefmodule Button do use Surface.Component prop click, :event def render(assigns) do ~F&quot;&quot;&quot; &lt;button class=&quot;button&quot; phx-click={{ @click }}&gt; &lt;#slot/&gt; &lt;/button&gt; &quot;&quot;&quot; end endNote: Stateless components cannot handle Phoenix LiveView events. If you need to handle them, please use a Surface.LiveComponent instead.","ref":"Surface.Component.html","title":"Surface.Component","type":"module"},{"doc":"A built-in component that allows users to set and retrieve values from the context.Propertiesput :context_put, accumulate: true, default: [] - Puts a value into the context.Usage&lt;Context put={{ scope, values }}&gt; ... &lt;/Context&gt;Where:scope - Optional. Is an atom representing the scope where the values will be stored. If no scope is provided, the value is stored at the root of the context map.values- A keyword list containing the key-value pairs that will be stored in the context.ExamplesWith scope:&lt;Context put={{ __MODULE__, form: @form }}&gt; ... &lt;/Context&gt;Without scope:&lt;Context put={{ key1: @value1, key2: &quot;some other value&quot; }}&gt; ... &lt;/Context&gt;.get :context_get, accumulate: true, default: [] - Retrieves a set of values from the context binding them to local variables.Usage&lt;Context get={{ scope, bindings }}&gt; ... &lt;/Context&gt;Where:scope - Optional. Is an atom representing the scope where the values will be stored. If no scope is provided, the value is stored at the root of the context map.bindings- A keyword list of bindings that will be retrieved from the context as local variables.Examples&lt;Context get={{ Form, form: form }} get={{ Field, field: my_field }}&gt; &lt;MyTextInput form={{ form }} field={{ my_field }} /&gt; &lt;/Context&gt;.Slotsdefault, required: true - The content of the &lt;Context&gt;.","ref":"Surface.Components.Context.html","title":"Surface.Components.Context","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Context.html#mount/1","title":"Surface.Components.Context.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Context.html#render/1","title":"Surface.Components.Context.render/1","type":"function"},{"doc":"Callback implementation for c:Surface.BaseComponent.transform/1.","ref":"Surface.Components.Context.html#transform/1","title":"Surface.Components.Context.transform/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Context.html#update/2","title":"Surface.Components.Context.update/2","type":"function"},{"doc":"Defines a form that lets the user submit information.Provides a wrapper for Phoenix.HTML.Form.form_for/3. Additionally, adds the form instance that is returned by form_for/3 into the context, making it available to any child input.All options passed via opts will be sent to form_for/3, for and action can be set directly and will override anything in opts.Propertiesfor :any, required: true - Atom or changeset to inform the form data.action :string, default: &quot;#&quot; - URL to where the form is submitted.as :atom - The server side parameter in which all parameters will be gathered..method :string - Method to be used when submitting the form..multipart :boolean, default: false - When true, sets enctype to &quot;multipart/form-data&quot;. Required when uploading files..csrf_token :any - For &quot;post&quot; requests, the form tag will automatically include an input tag with name _csrf_token. When set to false, this is disabled. .trigger_action :boolean - Trigger a standard form submit on DOM patch to the URL specified in the form's standard action attribute. This is useful to perform pre-final validation of a LiveView form submit before posting to a controller route for operations that require Plug session mutation. .errors :keyword - Keyword list of errors for the form..opts :keyword, default: [] - Keyword list with options to be passed down to Phoenix.HTML.Tag.tag/2.class :css_class - Class or classes to apply to the form.Slotsdefault, args: [:form] - The content of the &lt;form&gt;.Eventschange - Triggered when the form is changed.submit - Triggered when the form is submitted.auto_recover - Triggered when the form is being recovered. Use this event to enable specialized recovery when extra recovery handling on the server is required. .","ref":"Surface.Components.Form.html","title":"Surface.Components.Form","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.html#mount/1","title":"Surface.Components.Form.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.html#render/1","title":"Surface.Components.Form.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.html#update/2","title":"Surface.Components.Form.update/2","type":"function"},{"doc":"Defines a checkbox.Provides a wrapper for Phoenix.HTML.Form's checkbox/3 function.All options passed via opts will be sent to checkbox/3, value and class can be set directly and will override anything in opts.Examples&lt;Checkbox form=&quot;user&quot; field=&quot;color&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.checked_value :any, default: true - The value to be sent when the checkbox is checked. Defaults to &quot;true&quot;.hidden_input :boolean, default: true - Controls if this function will generate a hidden input to submit the unchecked value or not, defaults to &quot;true&quot;..unchecked_value :any, default: false - The value to be sent when the checkbox is unchecked, defaults to &quot;false&quot;..Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.Checkbox.html","title":"Surface.Components.Form.Checkbox","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.Checkbox.html#mount/1","title":"Surface.Components.Form.Checkbox.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Checkbox.html#render/1","title":"Surface.Components.Form.Checkbox.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.Checkbox.html#update/2","title":"Surface.Components.Form.Checkbox.update/2","type":"function"},{"doc":"An input field that let the user specify a color, either with a text field or a color picker interface.Provides a wrapper for Phoenix.HTML.Form's color_input/3 function.All options passed via opts will be sent to color_input/3, value and class can be set directly and will override anything in opts.Examples&lt;ColorInput form=&quot;user&quot; field=&quot;color&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.ColorInput.html","title":"Surface.Components.Form.ColorInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.ColorInput.html#mount/1","title":"Surface.Components.Form.ColorInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.ColorInput.html#render/1","title":"Surface.Components.Form.ColorInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.ColorInput.html#update/2","title":"Surface.Components.Form.ColorInput.update/2","type":"function"},{"doc":"An input field that let the user enter a date, either with a text field or a date picker interface.Provides a wrapper for Phoenix.HTML.Form's date_input/3 function.All options passed via opts will be sent to date_input/3, value and class can be set directly and will override anything in opts.Examples&lt;DateInput form=&quot;user&quot; field=&quot;birthday&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.DateInput.html","title":"Surface.Components.Form.DateInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.DateInput.html#mount/1","title":"Surface.Components.Form.DateInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.DateInput.html#render/1","title":"Surface.Components.Form.DateInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.DateInput.html#update/2","title":"Surface.Components.Form.DateInput.update/2","type":"function"},{"doc":"Generates select tags for date.Provides a wrapper for Phoenix.HTML.Form's date_select/3 function.All options passed via opts will be sent to date_select/3, value, default, year, month, day and builder can be set directly and will override anything in opts.Examples&lt;DateSelect form=&quot;user&quot; field=&quot;born_at&quot; /&gt; &lt;Form for={{ :user }}&gt; &lt;DateSelect field={{ :born_at }} /&gt; &lt;/Form&gt;Propertiesform :form - The form identifier.id :string - The id prefix for underlying select fields.name :string - The name prefix for underlying select fields.field :string - The field name.value :any - Value to pre-populate the select.default :any - Default value to use when none was given in 'value' and none is available in the form data.year :keyword - Options passed to the underlying 'year' select.month :keyword - Options passed to the underlying 'month' select.day :keyword - Options passed to the underlying 'day' select.builder :fun - Specify how the select can be build. It must be a function that receives a builder that should be invoked with the select name and a set of options. .opts :keyword, default: [] - Options list.","ref":"Surface.Components.Form.DateSelect.html","title":"Surface.Components.Form.DateSelect","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.DateSelect.html#mount/1","title":"Surface.Components.Form.DateSelect.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.DateSelect.html#render/1","title":"Surface.Components.Form.DateSelect.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.DateSelect.html#update/2","title":"Surface.Components.Form.DateSelect.update/2","type":"function"},{"doc":"An input field that let the user enter both date and time, using a text field and a date picker interface.Provides a wrapper for Phoenix.HTML.Form's datetime_local_input/3 function.All options passed via opts will be sent to datetime_local_input/3, value and class can be set directly and will override anything in opts.Examples&lt;DateTimeLocalInput form=&quot;order&quot; field=&quot;completed_at&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.DateTimeLocalInput.html","title":"Surface.Components.Form.DateTimeLocalInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.DateTimeLocalInput.html#mount/1","title":"Surface.Components.Form.DateTimeLocalInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.DateTimeLocalInput.html#render/1","title":"Surface.Components.Form.DateTimeLocalInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.DateTimeLocalInput.html#update/2","title":"Surface.Components.Form.DateTimeLocalInput.update/2","type":"function"},{"doc":"Generates select tags for datetime.Provides a wrapper for Phoenix.HTML.Form's datetime_select/3 function.All options passed via opts will be sent to datetime_select/3, value, default, year, month, day, hour, minute, second and builder can be set directly and will override anything in opts.Examples&lt;DateTimeSelect form=&quot;user&quot; field=&quot;born_at&quot; /&gt; &lt;Form for={{ :user }}&gt; &lt;DateTimeSelect field={{ :born_at }} /&gt; &lt;/Form&gt;Propertiesform :form - The form identifier.field :string - The field name.id :string - The id prefix for underlying select fields.name :string - The name prefix for underlying select fields.value :any - Value to pre-populate the select.default :any - Default value to use when none was given in 'value' and none is available in the form data.year :keyword - Options passed to the underlying 'year' select.month :keyword - Options passed to the underlying 'month' select.day :keyword - Options passed to the underlying 'day' select.hour :keyword - Options passed to the underlying 'day' select.minute :keyword - Options passed to the underlying 'day' select.second :keyword - Options passed to the underlying 'day' select.builder :fun - Specify how the select can be build. It must be a function that receives a builder that should be invoked with the select name and a set of options. .opts :keyword, default: [] - Options list.","ref":"Surface.Components.Form.DateTimeSelect.html","title":"Surface.Components.Form.DateTimeSelect","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.DateTimeSelect.html#mount/1","title":"Surface.Components.Form.DateTimeSelect.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.DateTimeSelect.html#render/1","title":"Surface.Components.Form.DateTimeSelect.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.DateTimeSelect.html#update/2","title":"Surface.Components.Form.DateTimeSelect.update/2","type":"function"},{"doc":"An input field that let the user enter one or multiple e-mails.Provides a wrapper for Phoenix.HTML.Form's email_input/3 function.All options passed via opts will be sent to email_input/3, value and class can be set directly and will override anything in opts.Examples&lt;EmailInput form=&quot;user&quot; field=&quot;email&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.EmailInput.html","title":"Surface.Components.Form.EmailInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.EmailInput.html#mount/1","title":"Surface.Components.Form.EmailInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.EmailInput.html#render/1","title":"Surface.Components.Form.EmailInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.EmailInput.html#update/2","title":"Surface.Components.Form.EmailInput.update/2","type":"function"},{"doc":"A component inspired by error_tag/3 that ships with mix phx.new in MyAppWeb.ErrorHelpers.Renders error messages if any exist regarding the given field.Error TranslationChangeset errors are translated using the default error translator that ships with phoenix when generated with mix phx.new --no-gettext.When using Gettext, you can use configuration to route all errors through the MyAppWeb.ErrorHelpers.translate_error/1 function generated by Phoenix, which utilizes Gettext. You need to provide a tuple with the module and the name of the function (as an atom) as follows:config :surface, :components, [ {Surface.Components.Form.ErrorTag, default_translator: {MyAppWeb.ErrorHelpers, :translate_error}} ]There is also a translator prop which can be used on a case-by-case basis. It overrides the configuration.Examples&lt;ErrorTag field=&quot;password&quot; /&gt;&lt;Field name=&quot;password&quot;&gt; &lt;ErrorTag /&gt; &lt;/Field&gt;&lt;ErrorTag feedback_for=&quot;confirm_password_for_reset&quot; /&gt;&lt;ErrorTag class=&quot;custom-css-classes&quot; /&gt;&lt;ErrorTag translator={{ &amp;CustomTranslationLib.translate_error/1 }} /&gt;Propertiesform :form - An identifier for the form.field :any - An identifier for the associated field.class :css_class - Classes to apply to each error tag &lt;span&gt;.This can also be set via config, for example:config :surface, :components, [ {Surface.Components.Form.ErrorTag, default_class: &quot;invalid-feedback&quot;} ]However, the prop overrides the config value if provided. .translator :fun - A function that takes one argument {msg, opts} and returns the translated error message as a string. If not provided, falls back to Phoenix's default implementation.This can also be set via config, for example:config :surface, :components, [ {Surface.Components.Form.ErrorTag, default_translator: {MyApp.Gettext, :translate_error}} ].feedback_for :string - If you changed the default ID on the input, provide it here. (Useful when there are multiple forms on the same page, each with an input of the same name. LiveView will exhibit buggy behavior without assigning separate id's to each.) .","ref":"Surface.Components.Form.ErrorTag.html","title":"Surface.Components.Form.ErrorTag","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.ErrorTag.html#mount/1","title":"Surface.Components.Form.ErrorTag.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.ErrorTag.html#render/1","title":"Surface.Components.Form.ErrorTag.render/1","type":"function"},{"doc":"Translates an error message.This is the fallback (Phoenix's default implementation) if a translator is not provided via config or the translate prop.","ref":"Surface.Components.Form.ErrorTag.html#translate_error/1","title":"Surface.Components.Form.ErrorTag.translate_error/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.ErrorTag.html#update/2","title":"Surface.Components.Form.ErrorTag.update/2","type":"function"},{"doc":"Defines a form field.The Field component sets the provided field name into the context so child components like input fields and labels can retrieve it and use it as the default field.Propertiesname :any, required: true - The field name.class :css_class - The CSS class for the generated &lt;div&gt; element.Slotsdefault, required: true - The content for the field .","ref":"Surface.Components.Form.Field.html","title":"Surface.Components.Form.Field","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.Field.html#mount/1","title":"Surface.Components.Form.Field.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Field.html#render/1","title":"Surface.Components.Form.Field.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.Field.html#update/2","title":"Surface.Components.Form.Field.update/2","type":"function"},{"doc":"Defines a context for a form field but without the &lt;div&gt; wrapper in Field.Like the Field component, sets the provided field name into the context so child components like input fields and labels can retrieve it and use it as the default field.Propertiesname :any, required: true - The field name.Slotsdefault, required: true - The content for the field .","ref":"Surface.Components.Form.FieldContext.html","title":"Surface.Components.Form.FieldContext","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.FieldContext.html#mount/1","title":"Surface.Components.Form.FieldContext.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.FieldContext.html#render/1","title":"Surface.Components.Form.FieldContext.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.FieldContext.html#update/2","title":"Surface.Components.Form.FieldContext.update/2","type":"function"},{"doc":"Generates a file input.It requires the given form to be configured with multipart: true.All options passed via opts will be sent to file_input/3, value and class can be set directly and will override anything in opts.Examples&lt;FileInput form=&quot;user&quot; field=&quot;picture&quot; /&gt; &lt;Form for={{ :user }} opts={{ multipart: true }}&gt; &lt;FileInput field={{ :picture }} /&gt; &lt;/Form&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.FileInput.html","title":"Surface.Components.Form.FileInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.FileInput.html#mount/1","title":"Surface.Components.Form.FileInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.FileInput.html#render/1","title":"Surface.Components.Form.FileInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.FileInput.html#update/2","title":"Surface.Components.Form.FileInput.update/2","type":"function"},{"doc":"A hidden input field.Provides a wrapper for Phoenix.HTML.Form's hidden_input/3 function.All options passed via opts will be sent to hidden_input/3, value and class can be set directly and will override anything in opts.Examples&lt;HiddenInput form=&quot;user&quot; field=&quot;token&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.HiddenInput.html","title":"Surface.Components.Form.HiddenInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.HiddenInput.html#mount/1","title":"Surface.Components.Form.HiddenInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.HiddenInput.html#render/1","title":"Surface.Components.Form.HiddenInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.HiddenInput.html#update/2","title":"Surface.Components.Form.HiddenInput.update/2","type":"function"},{"doc":"A wrapper for Phoenix.HTML.Form.html.hidden_inputs_for/1.Generates hidden inputs for the given form.Propertiesfor :form - The form.It should either be a Phoenix.HTML.Form emitted by form_for, inputs_for or an atom. .","ref":"Surface.Components.Form.HiddenInputs.html","title":"Surface.Components.Form.HiddenInputs","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.HiddenInputs.html#mount/1","title":"Surface.Components.Form.HiddenInputs.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.HiddenInputs.html#render/1","title":"Surface.Components.Form.HiddenInputs.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.HiddenInputs.html#update/2","title":"Surface.Components.Form.HiddenInputs.update/2","type":"function"},{"doc":"Propertiesassigns :map - The assigns of the host component.Slotsdefault, args: [:form, :field]","ref":"Surface.Components.Form.Input.InputContext.html","title":"Surface.Components.Form.Input.InputContext","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.Input.InputContext.html#mount/1","title":"Surface.Components.Form.Input.InputContext.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Input.InputContext.html#render/1","title":"Surface.Components.Form.Input.InputContext.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.Input.InputContext.html#update/2","title":"Surface.Components.Form.Input.InputContext.update/2","type":"function"},{"doc":"A wrapper for Phoenix.HTML.Form.html.inputs_for/3.Additionally, adds the generated form instance that is returned by inputs_for/3 into the context, making it available to any child input.Propertiesform :form - The parent form.It should either be a Phoenix.HTML.Form emitted by form_for or an atom. .for :atom - The name of the field related to the child inputs. .opts :keyword, default: [] - Extra options for inputs_for/3.See Phoenix.HTML.Form.html.inputs_for/4 for the available options. .Slotsdefault, args: [:form, :index] - The code containing the input controls.","ref":"Surface.Components.Form.Inputs.html","title":"Surface.Components.Form.Inputs","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.Inputs.html#mount/1","title":"Surface.Components.Form.Inputs.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Inputs.html#render/1","title":"Surface.Components.Form.Inputs.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.Inputs.html#update/2","title":"Surface.Components.Form.Inputs.update/2","type":"function"},{"doc":"Defines a label.Provides similar capabilities to Phoenix's built-in label/2 function.Option class can be set directly and will override anything in opts.All given options are forwarded to the underlying tag. A default value is provided for for attribute but can be overriden if you pass a value to the for option. Text content would be inferred from field if not specified.Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - The form identifier.field :any - The field name.class :css_class - The CSS class for the underlying tag.text :any - The text for the generated &lt;label&gt; element, if no content (default slot) is provided. .opts :keyword, default: [] - Options list.Slotsdefault - The text for the label .Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.Label.html","title":"Surface.Components.Form.Label","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.Label.html#mount/1","title":"Surface.Components.Form.Label.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Label.html#render/1","title":"Surface.Components.Form.Label.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.Label.html#update/2","title":"Surface.Components.Form.Label.update/2","type":"function"},{"doc":"Defines a select.Provides a wrapper for Phoenix.HTML.Form's multiple_select/4 function.All options passed via opts will be sent to multiple_select/4, class can be set directly and will override anything in opts.Propertiesform :form - The form identifier.field :string - The field name.id :string - The id of the corresponding select field.name :string - The name of the corresponding select field.class :css_class - The CSS class for the underlying tag.options :any, default: [] - The options in the select.selected :any - The default selected option.opts :keyword, default: [] - Options list.","ref":"Surface.Components.Form.MultipleSelect.html","title":"Surface.Components.Form.MultipleSelect","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.MultipleSelect.html#mount/1","title":"Surface.Components.Form.MultipleSelect.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.MultipleSelect.html#render/1","title":"Surface.Components.Form.MultipleSelect.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.MultipleSelect.html#update/2","title":"Surface.Components.Form.MultipleSelect.update/2","type":"function"},{"doc":"An input field that let the user to enter a number.Provides a wrapper for Phoenix.HTML.Form's number_input/3 function.All options passed via opts will be sent to number_input/3, value and class can be set directly and will override anything in opts.Examples&lt;NumberInput form=&quot;user&quot; field=&quot;age&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.NumberInput.html","title":"Surface.Components.Form.NumberInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.NumberInput.html#mount/1","title":"Surface.Components.Form.NumberInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.NumberInput.html#render/1","title":"Surface.Components.Form.NumberInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.NumberInput.html#update/2","title":"Surface.Components.Form.NumberInput.update/2","type":"function"},{"doc":"Defines options to be used inside a select.This is useful when building the select by hand.Provides a wrapper for Phoenix.HTML.Form's options_for_select/2 function.Propertiesoptions :any, default: [] - The options in the select.selected :any, default: nil - The selected values.","ref":"Surface.Components.Form.OptionsForSelect.html","title":"Surface.Components.Form.OptionsForSelect","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.OptionsForSelect.html#mount/1","title":"Surface.Components.Form.OptionsForSelect.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.OptionsForSelect.html#render/1","title":"Surface.Components.Form.OptionsForSelect.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.OptionsForSelect.html#update/2","title":"Surface.Components.Form.OptionsForSelect.update/2","type":"function"},{"doc":"An input field that let the user securely specify a password.Provides a wrapper for Phoenix.HTML.Form's password_input/3 function.All options passed via opts will be sent to password_input/3, value and class can be set directly and will override anything in opts.Examples&lt;PasswordInput form=&quot;user&quot; field=&quot;password&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.PasswordInput.html","title":"Surface.Components.Form.PasswordInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.PasswordInput.html#mount/1","title":"Surface.Components.Form.PasswordInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.PasswordInput.html#render/1","title":"Surface.Components.Form.PasswordInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.PasswordInput.html#update/2","title":"Surface.Components.Form.PasswordInput.update/2","type":"function"},{"doc":"Defines a radio button.Provides a wrapper for Phoenix.HTML.Form's radio_button/4 function.All options passed via opts will be sent to radio_button/4, value and class can be set directly and will override anything in opts.Examples&lt;RadioButton form=&quot;user&quot; field=&quot;color&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.checked :boolean - Indicates whether or not the radio button is the selected item in the group.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.RadioButton.html","title":"Surface.Components.Form.RadioButton","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.RadioButton.html#mount/1","title":"Surface.Components.Form.RadioButton.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.RadioButton.html#render/1","title":"Surface.Components.Form.RadioButton.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.RadioButton.html#update/2","title":"Surface.Components.Form.RadioButton.update/2","type":"function"},{"doc":"An input field that let the user specify a numeric value in a given range, usually using a slider.Provides a wrapper for Phoenix.HTML.Form's range_input/3 function.All options passed via opts will be sent to range_input/3, value, min, max and class can be set directly and will override anything in opts.Examples&lt;RangeInput form=&quot;volume&quot; field=&quot;percent&quot; min=&quot;0&quot; max=&quot;100&quot; step=&quot;5&quot; value=&quot;40&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.min :string - Minimum value for the input.max :string - Maximum value for the input.step :string - Sets or returns the value of the step attribute of the slider control.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.RangeInput.html","title":"Surface.Components.Form.RangeInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.RangeInput.html#mount/1","title":"Surface.Components.Form.RangeInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.RangeInput.html#render/1","title":"Surface.Components.Form.RangeInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.RangeInput.html#update/2","title":"Surface.Components.Form.RangeInput.update/2","type":"function"},{"doc":"Defines a reset button.Provides a wrapper for Phoenix.HTML.Form's reset/2 function.All options passed via opts will be sent to reset/2, value and class can be set directly and will override anything in opts.Examples&lt;Reset value=&quot;Reset&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string, default: &quot;Reset&quot; - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Keyword list with options to be passed down to reset/2.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.Reset.html","title":"Surface.Components.Form.Reset","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.Reset.html#mount/1","title":"Surface.Components.Form.Reset.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Reset.html#render/1","title":"Surface.Components.Form.Reset.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.Reset.html#update/2","title":"Surface.Components.Form.Reset.update/2","type":"function"},{"doc":"An input field that let the user enter search queries.Provides a wrapper for Phoenix.HTML.Form's search_input/3 function.All options passed via opts will be sent to search_input/3, value and class can be set directly and will override anything in opts.Examples&lt;SearchInput form=&quot;song&quot; field=&quot;title&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.SearchInput.html","title":"Surface.Components.Form.SearchInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.SearchInput.html#mount/1","title":"Surface.Components.Form.SearchInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.SearchInput.html#render/1","title":"Surface.Components.Form.SearchInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.SearchInput.html#update/2","title":"Surface.Components.Form.SearchInput.update/2","type":"function"},{"doc":"Defines a select.Provides a wrapper for Phoenix.HTML.Form's select/4 function.All options passed via opts will be sent to select/4, class can be set directly and will override anything in opts.Propertiesform :form - The form identifier.field :string - The field name.id :string - The id of the corresponding select field.name :string - The name of the corresponding select field.class :css_class - The CSS class for the underlying tag.options :any, default: [] - The options in the select.prompt :string - An option to include at the top of the options with the given prompt text.selected :any - The default value to use when none was sent as parameter.opts :keyword, default: [] - Options list.","ref":"Surface.Components.Form.Select.html","title":"Surface.Components.Form.Select","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.Select.html#mount/1","title":"Surface.Components.Form.Select.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Select.html#render/1","title":"Surface.Components.Form.Select.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.Select.html#update/2","title":"Surface.Components.Form.Select.update/2","type":"function"},{"doc":"Defines a submit button to send the form.All options are forwarded to the underlying Phoenix.HTML.Form.submit/3Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.label :string - The label to be used in the button.class :css_class - Class or classes to apply to the button.opts :keyword, default: [] - Keyword list with options to be passed down to submit/3.Slotsdefault - Slot used for having children other than plain text in the button.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.Submit.html","title":"Surface.Components.Form.Submit","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.Submit.html#mount/1","title":"Surface.Components.Form.Submit.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.Submit.html#render/1","title":"Surface.Components.Form.Submit.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.Submit.html#update/2","title":"Surface.Components.Form.Submit.update/2","type":"function"},{"doc":"An input field that let the user enter a telephone number.Provides a wrapper for Phoenix.HTML.Form's telephone_input/3 function.All options passed via opts will be sent to telephone_input/3, value, pattern and class can be set directly and will override anything in opts.Examples&lt;TelephoneInput form=&quot;user&quot; field=&quot;phone&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.pattern :string - A regular expression to validate the entered value.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.TelephoneInput.html","title":"Surface.Components.Form.TelephoneInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.TelephoneInput.html#mount/1","title":"Surface.Components.Form.TelephoneInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.TelephoneInput.html#render/1","title":"Surface.Components.Form.TelephoneInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.TelephoneInput.html#update/2","title":"Surface.Components.Form.TelephoneInput.update/2","type":"function"},{"doc":"An input field that let the user enter a multi-line text.Provides a wrapper for Phoenix.HTML.Form's textarea/3 function.All options passed via opts will be sent to textarea/3. Explicitly defined properties like value and class can be set directly and will override anything in opts.Examples&lt;TextArea form=&quot;user&quot; field=&quot;summary&quot; cols=&quot;5&quot; rows=&quot;10&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.rows :string - Specifies the visible number of lines in a text area.cols :string - Specifies the visible width of a text area.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.TextArea.html","title":"Surface.Components.Form.TextArea","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.TextArea.html#mount/1","title":"Surface.Components.Form.TextArea.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.TextArea.html#render/1","title":"Surface.Components.Form.TextArea.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.TextArea.html#update/2","title":"Surface.Components.Form.TextArea.update/2","type":"function"},{"doc":"An input field that let the user enter a single-line text.Provides a wrapper for Phoenix.HTML.Form's text_input/3 function.All options passed via opts will be sent to text_input/3, value and class can be set directly and will override anything in opts.Examples&lt;TextInput form=&quot;user&quot; field=&quot;name&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.TextInput.html","title":"Surface.Components.Form.TextInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.TextInput.html#mount/1","title":"Surface.Components.Form.TextInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.TextInput.html#render/1","title":"Surface.Components.Form.TextInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.TextInput.html#update/2","title":"Surface.Components.Form.TextInput.update/2","type":"function"},{"doc":"An input field that let the user enter a time (hours, minutes and optionally seconds).Provides a wrapper for Phoenix.HTML.Form's time_input/3 function.All options passed via opts will be sent to time_input/3, value and class can be set directly and will override anything in opts.Examples&lt;TimeInput form=&quot;user&quot; field=&quot;name&quot; opts={{ autofocus: &quot;autofocus&quot; }} /&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.TimeInput.html","title":"Surface.Components.Form.TimeInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.TimeInput.html#mount/1","title":"Surface.Components.Form.TimeInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.TimeInput.html#render/1","title":"Surface.Components.Form.TimeInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.TimeInput.html#update/2","title":"Surface.Components.Form.TimeInput.update/2","type":"function"},{"doc":"Generates select tags for time.Provides a wrapper for Phoenix.HTML.Form's time_select/3 function.All options passed via opts will be sent to time_select/3, value, default, hour, minute, second and builder can be set directly and will override anything in opts.Examples&lt;TimeSelect form=&quot;alarm&quot; field=&quot;time&quot; /&gt; &lt;Form for={{ :alarm }}&gt; &lt;TimeSelect field={{ :time }} /&gt; &lt;/Form&gt;Propertiesform :form - The form identifier.field :string - The field name.id :string - The id prefix for underlying select fields.name :string - The name prefix for underlying select fields.value :any - Value to pre-populate the select.default :any - Default value to use when none was given in 'value' and none is available in the form data.hour :keyword - Options passed to the underlying 'day' select.minute :keyword - Options passed to the underlying 'day' select.second :keyword - Options passed to the underlying 'day' select.builder :fun - Specify how the select can be build. It must be a function that receives a builder that should be invoked with the select name and a set of options. .opts :keyword, default: [] - Options list.","ref":"Surface.Components.Form.TimeSelect.html","title":"Surface.Components.Form.TimeSelect","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.TimeSelect.html#mount/1","title":"Surface.Components.Form.TimeSelect.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.TimeSelect.html#render/1","title":"Surface.Components.Form.TimeSelect.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.TimeSelect.html#update/2","title":"Surface.Components.Form.TimeSelect.update/2","type":"function"},{"doc":"An input field that let the user enter a URL.Provides a wrapper for Phoenix.HTML.Form's url_input/3 function.All options passed via opts will be sent to url_input/3, value and class can be set directly and will override anything in opts.Examples&lt;UrlInput form=&quot;user&quot; field=&quot;name&quot; opts={{ autofocus: &quot;autofocus&quot; }}&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.form :form - An identifier for the form.field :any - An identifier for the input.id :string - The id of the corresponding input field.name :string - The name of the corresponding input field.value :string - Value to pre-populated the input.class :css_class - Class or classes to apply to the input.opts :keyword, default: [] - Options list.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Form.UrlInput.html","title":"Surface.Components.Form.UrlInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Form.UrlInput.html#mount/1","title":"Surface.Components.Form.UrlInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Form.UrlInput.html#render/1","title":"Surface.Components.Form.UrlInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Form.UrlInput.html#update/2","title":"Surface.Components.Form.UrlInput.update/2","type":"function"},{"doc":"Generates a link to the given URL.Provides similar capabilities to Phoenix's built-in link/2 function.Options label and class can be set directly and will override anything in opts. All other options are forwarded to the underlying &lt;a&gt; tag.Examples&lt;Link label=&quot;user&quot; to=&quot;/users/1&quot; class=&quot;is-danger&quot; method={{ :delete }} opts={{ data: [confirm: &quot;Really?&quot;] }} /&gt; &lt;Link to=&quot;/users/1&quot; class=&quot;is-link&quot; &gt; &lt;span&gt;user&lt;/span&gt; &lt;/Link&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.to :any, required: true - The page to link to.method :atom, default: :get - The method to use with the link.id :string - Id to apply to the link.class :css_class - Class or classes to apply to the link.label :string - The label for the generated &lt;a&gt; element, if no content (default slot) is provided. .opts :keyword, default: [] - Additional attributes to add onto the generated element .Slotsdefault - The content of the generated &lt;a&gt; element. If no content is provided, the value of property label is used instead. .Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Link.html","title":"Surface.Components.Link","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Link.html#mount/1","title":"Surface.Components.Link.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Link.html#render/1","title":"Surface.Components.Link.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Link.html#update/2","title":"Surface.Components.Link.update/2","type":"function"},{"doc":"Generates a button that uses a regular HTML form to submit to the given URL.Useful to ensure that links that change data are not triggered by search engines and other spidering software.Provides similar capabilities to Phoenix's built-in button/2 function.Options label and class can be set directly and will override anything in opts. All other options are forwarded to the underlying &lt;button&gt; tag.Examples&lt;Button label=&quot;user&quot; to=&quot;/users/1&quot; class=&quot;is-danger&quot; method={{ :delete }} opts={{ data: [confirm: &quot;Really?&quot;] }} /&gt; &lt;Button to=&quot;/users/1&quot; class=&quot;is-link&quot; &gt; &lt;span&gt;user&lt;/span&gt; &lt;/Button&gt;Propertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.to :any, required: true - The page to link to.method :atom, default: :post - The method to use with the button.id :string - Id to apply to the button.class :css_class - Class or classes to apply to the button.label :string - The label for the generated &lt;button&gt; element, if no content (default slot) is provided. .opts :keyword, default: [] - Additional attributes to add onto the generated element .Slotsdefault - The content of the generated &lt;button&gt; element. If no content is provided, the value of property label is used instead. .Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.Link.Button.html","title":"Surface.Components.Link.Button","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.Link.Button.html#mount/1","title":"Surface.Components.Link.Button.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.Link.Button.html#render/1","title":"Surface.Components.Link.Button.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.Link.Button.html#update/2","title":"Surface.Components.Link.Button.update/2","type":"function"},{"doc":"Wrapper around Phoenix LiveView's built-in live_file_input/2 function.The parent LiveView, or LiveComponent must allow_uploads during mount: def mount(socket) do socket = allow_upload(socket, :avatar, accept: ~w(.json), max_entries: 1) {:ok, socket} endSee Phoenix.LiveView Uploads documentationPropertiesvalues :keyword, default: [] - List values that will be sent as part of the payload triggered by an event.upload :struct, required: true - Upload specified via allow_upload.class :css_class - The CSS class for the generated &lt;input&gt; element.opts :keyword, default: [] - Keyword list with options to be passed down to live_file_input/2.Eventscapture_click - Triggered when the component captures click.click - Triggered when the component receives click.window_focus - Triggered when the page receives focus.window_blur - Triggered when the page loses focus.focus - Triggered when the component receives focus.blur - Triggered when the component loses focus.window_keyup - Triggered when a key on the keyboard is released (window-level).window_keydown - Triggered when a key on the keyboard is pressed (window-level).keyup - Triggered when a key on the keyboard is released.keydown - Triggered when a key on the keyboard is pressed.","ref":"Surface.Components.LiveFileInput.html","title":"Surface.Components.LiveFileInput","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.LiveFileInput.html#mount/1","title":"Surface.Components.LiveFileInput.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.LiveFileInput.html#render/1","title":"Surface.Components.LiveFileInput.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.LiveFileInput.html#update/2","title":"Surface.Components.LiveFileInput.update/2","type":"function"},{"doc":"Defines a link that will patch the current LiveView.Provides similar capabilities to Phoenix's built-in live_patch/2 function.When navigating to the current LiveView, handle_params/3 is immediately invoked to handle the change of params and URL state. Then the new state is pushed to the client, without reloading the whole page. For live redirects to another LiveView, use &lt;LiveRedirect&gt; instead.Propertiesto :string, required: true - The required path to link to.replace :boolean, default: false - The flag to replace the current history or push a new state.class :css_class, default: &quot;&quot; - The CSS class for the generated &lt;a&gt; element.label :string - The label for the generated &lt;a&gt; alement, if no content (default slot) is provided. .opts :keyword, default: [] - Additional attributes to add onto the generated element .Slotsdefault - The content of the generated &lt;a&gt; element. If no content is provided, the value of property label is used instead. .","ref":"Surface.Components.LivePatch.html","title":"Surface.Components.LivePatch","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.LivePatch.html#mount/1","title":"Surface.Components.LivePatch.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.LivePatch.html#render/1","title":"Surface.Components.LivePatch.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.LivePatch.html#update/2","title":"Surface.Components.LivePatch.update/2","type":"function"},{"doc":"Defines a link that will redirect to a new LiveView.Provides similar capabilities to Phoenix's built-in live_redirect/2 function.The current LiveView will be shut down and a new one will be mounted in its place, without reloading the whole page. This can also be used to remount the same LiveView, in case you want to start fresh. If you want to navigate to the same LiveView without remounting it, use &lt;LivePatch&gt; instead.Propertiesto :string, required: true - The required path to link to.replace :boolean, default: false - The flag to replace the current history or push a new state.class :css_class, default: &quot;&quot; - The CSS class for the generated &lt;a&gt; element.label :string - The label for the generated &lt;a&gt; alement, if no content (default slot) is provided. .opts :keyword, default: [] - Additional attributes to add onto the generated element .Slotsdefault - The content of the generated &lt;a&gt; element. If no content is provided, the value of property label is used instead. .","ref":"Surface.Components.LiveRedirect.html","title":"Surface.Components.LiveRedirect","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1.","ref":"Surface.Components.LiveRedirect.html#mount/1","title":"Surface.Components.LiveRedirect.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.LiveRedirect.html#render/1","title":"Surface.Components.LiveRedirect.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2.","ref":"Surface.Components.LiveRedirect.html#update/2","title":"Surface.Components.LiveRedirect.update/2","type":"function"},{"doc":"A macro component that does not translate any of its contents.The content will be passed untouched to the underlying Phoenix's template engine.Note: By skipping translation, all Surface specific features are automatically disabled, including code interpolation with {{...}}, syntactic sugar for attributes and markup validation.Slotsdefault - The content that will not be translated by Surface.","ref":"Surface.Components.Raw.html","title":"Surface.Components.Raw","type":"module"},{"doc":"Callback implementation for Surface.MacroComponent.expand/3.","ref":"Surface.Components.Raw.html#expand/3","title":"Surface.Components.Raw.expand/3","type":"function"},{"doc":"","ref":"Surface.Directive.html","title":"Surface.Directive","type":"behaviour"},{"doc":"","ref":"Surface.Directive.html#c:extract/2","title":"Surface.Directive.extract/2","type":"callback"},{"doc":"","ref":"Surface.Directive.html#c:process/2","title":"Surface.Directive.process/2","type":"callback"},{"doc":"","ref":"Surface.Directive.ComponentProps.html","title":"Surface.Directive.ComponentProps","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.ComponentProps.html#extract/2","title":"Surface.Directive.ComponentProps.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.ComponentProps.html#process/2","title":"Surface.Directive.ComponentProps.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Debug.html","title":"Surface.Directive.Debug","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.Debug.html#extract/2","title":"Surface.Directive.Debug.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.Debug.html#process/2","title":"Surface.Directive.Debug.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Events.html","title":"Surface.Directive.Events","type":"module"},{"doc":"","ref":"Surface.Directive.Events.html#event_name/1","title":"Surface.Directive.Events.event_name/1","type":"function"},{"doc":"","ref":"Surface.Directive.Events.html#event_target/2","title":"Surface.Directive.Events.event_target/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.Events.html#extract/2","title":"Surface.Directive.Events.extract/2","type":"function"},{"doc":"","ref":"Surface.Directive.Events.html#phx_events/0","title":"Surface.Directive.Events.phx_events/0","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.Events.html#process/2","title":"Surface.Directive.Events.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.For.html","title":"Surface.Directive.For","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.For.html#extract/2","title":"Surface.Directive.For.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.For.html#process/2","title":"Surface.Directive.For.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Hook.html","title":"Surface.Directive.Hook","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.Hook.html#extract/2","title":"Surface.Directive.Hook.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.Hook.html#process/2","title":"Surface.Directive.Hook.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.If.html","title":"Surface.Directive.If","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.If.html#extract/2","title":"Surface.Directive.If.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.If.html#process/2","title":"Surface.Directive.If.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Let.html","title":"Surface.Directive.Let","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.Let.html#extract/2","title":"Surface.Directive.Let.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.Let.html#process/2","title":"Surface.Directive.Let.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Show.html","title":"Surface.Directive.Show","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.Show.html#extract/2","title":"Surface.Directive.Show.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.Show.html#process/2","title":"Surface.Directive.Show.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.SlotProps.html","title":"Surface.Directive.SlotProps","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.SlotProps.html#extract/2","title":"Surface.Directive.SlotProps.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.SlotProps.html#process/2","title":"Surface.Directive.SlotProps.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.TagAttrs.html","title":"Surface.Directive.TagAttrs","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.TagAttrs.html#extract/2","title":"Surface.Directive.TagAttrs.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.TagAttrs.html#process/2","title":"Surface.Directive.TagAttrs.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Values.html","title":"Surface.Directive.Values","type":"module"},{"doc":"Callback implementation for Surface.Directive.extract/2.","ref":"Surface.Directive.Values.html#extract/2","title":"Surface.Directive.Values.extract/2","type":"function"},{"doc":"Callback implementation for Surface.Directive.process/2.","ref":"Surface.Directive.Values.html#process/2","title":"Surface.Directive.Values.process/2","type":"function"},{"doc":"","ref":"Surface.Directive.Values.html#validate_value!/2","title":"Surface.Directive.Values.validate_value!/2","type":"function"},{"doc":"","ref":"Surface.AST.html","title":"Surface.AST","type":"module"},{"doc":"","ref":"Surface.AST.html#find_attribute_value/2","title":"Surface.AST.find_attribute_value/2","type":"function"},{"doc":"","ref":"Surface.AST.html#t:t/0","title":"Surface.AST.t/0","type":"type"},{"doc":"An AST node representing an attribute or propertyProperties* `:type` - an atom representing the type of attribute. See Surface.API for the list of supported types * `:type_opts` - a keyword list of options for the type * `:name` - the name of the attribute (e.g. `:class`) * `:value` - a list of nodes that can be concatenated to form the value for this attribute. Potentially contains dynamic data * `:meta` - compilation meta data","ref":"Surface.AST.Attribute.html","title":"Surface.AST.Attribute","type":"module"},{"doc":"","ref":"Surface.AST.Attribute.html#t:t/0","title":"Surface.AST.Attribute.t/0","type":"type"},{"doc":"An AST node representing an attribute expression (i.e. a dynamic value for an attribute, directive, or property)Properties* `:original` - the original text, useful for debugging and error messages * `:value` - a quoted expression * `:constant?` - true if the expression can be evaluated at compile time * `:meta` - compilation meta data","ref":"Surface.AST.AttributeExpr.html","title":"Surface.AST.AttributeExpr","type":"module"},{"doc":"","ref":"Surface.AST.AttributeExpr.html#new/3","title":"Surface.AST.AttributeExpr.new/3","type":"function"},{"doc":"","ref":"Surface.AST.AttributeExpr.html#t:t/0","title":"Surface.AST.AttributeExpr.t/0","type":"type"},{"doc":"An AST node representing a generic block.Properties* `:name` - name of the block * `:expression` - the expression passed to block * `:sub_blocks` - a list containing each sub-block&#39;s {name, children_ast} * `:meta` - compile meta * `:debug` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.Block.html","title":"Surface.AST.Block","type":"module"},{"doc":"","ref":"Surface.AST.Block.html#t:t/0","title":"Surface.AST.Block.t/0","type":"type"},{"doc":"An AST node representing a standard HTML tagProperties* `:module` - the component module * `:type` - the type of component (i.e. Surface.LiveComponent vs Surface.LiveView) * `:props` - the props for this component * `:directives` - any directives to be applied to this tag * `:children` - the tag children * `:meta` - compilation meta data * `:debug` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.Component.html","title":"Surface.AST.Component","type":"module"},{"doc":"","ref":"Surface.AST.Component.html#t:t/0","title":"Surface.AST.Component.t/0","type":"type"},{"doc":"An AST node representing a container of other nodes. This does not have content itself, just contains children which have content, and directives that operate on the entirety of the children (i.e. for, if, debug)Properties* `:children` - children AST nodes * `:directives` - directives associated with this container * `:meta` - compile meta * `:debug` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.Container.html","title":"Surface.AST.Container","type":"module"},{"doc":"","ref":"Surface.AST.Container.html#t:t/0","title":"Surface.AST.Container.t/0","type":"type"},{"doc":"An AST node representing a directiveProperties* `:module` - the module which implements logic for this directive (e.g. `Surface.Directive.Let`) * `:name` - the name of the directive (e.g. `:let`) * `:value` - the code/configuration for this directive. typically a quoted expression * `:meta` - compilation meta data","ref":"Surface.AST.Directive.html","title":"Surface.AST.Directive","type":"module"},{"doc":"","ref":"Surface.AST.Directive.html#t:t/0","title":"Surface.AST.Directive.t/0","type":"type"},{"doc":"An AST node representing a dynamic attribute (or attributes).Properties* `:expr` - an expression which will generate a keyword list of attributes and value tuples of the form {type, value} * `:meta` - compilation meta data","ref":"Surface.AST.DynamicAttribute.html","title":"Surface.AST.DynamicAttribute","type":"module"},{"doc":"","ref":"Surface.AST.DynamicAttribute.html#t:t/0","title":"Surface.AST.DynamicAttribute.t/0","type":"type"},{"doc":"An AST node representing an error. This will be rendered as an html element.Properties* `:message` - the error message * `:meta` - compilation meta data * `:directives` - directives associated with this error node","ref":"Surface.AST.Error.html","title":"Surface.AST.Error","type":"module"},{"doc":"","ref":"Surface.AST.Error.html#t:t/0","title":"Surface.AST.Error.t/0","type":"type"},{"doc":"An AST node representing an expression which does not resolve to a value printed out to the final DOM.Properties* `:value` - a quoted expression * `:constant?` - true if the expression can be evaluated at compile time * `:meta` - compile meta * `:directives` - directives associated with this expression node","ref":"Surface.AST.Expr.html","title":"Surface.AST.Expr","type":"module"},{"doc":"","ref":"Surface.AST.Expr.html#t:t/0","title":"Surface.AST.Expr.t/0","type":"type"},{"doc":"An AST node representing a for comprehension.Properties* `:generator` - a quoted expression * `:children` - the children to collect over the generator * `:meta` - compilation meta data * `:debug` - keyword list indicating when debug information should be printed during compilation * `:directives` - directives associated with this node","ref":"Surface.AST.For.html","title":"Surface.AST.For","type":"module"},{"doc":"","ref":"Surface.AST.For.html#t:t/0","title":"Surface.AST.For.t/0","type":"type"},{"doc":"An AST node representing an if/else expressionProperties* `:condition` - a quoted expression * `:children` - the children to insert into the dom if the condition evaluates truthy * `:else` - the children to insert into the dom if the condition evaluates falsy * `:meta` - compilation meta data * `:debug` - keyword list indicating when debug information should be printed during compilation * `:directives` - directives associated with this node","ref":"Surface.AST.If.html","title":"Surface.AST.If","type":"module"},{"doc":"","ref":"Surface.AST.If.html#t:t/0","title":"Surface.AST.If.t/0","type":"type"},{"doc":"An AST node representing interpolation within a nodeProperties* `:original` - the original text, useful for debugging and error messages * `:value` - a quoted expression * `:constant?` - true if the expression can be evaluated at compile time * `:meta` - compilation meta data * `:directives` - directives associated with this interpolation","ref":"Surface.AST.Interpolation.html","title":"Surface.AST.Interpolation","type":"module"},{"doc":"","ref":"Surface.AST.Interpolation.html#t:t/0","title":"Surface.AST.Interpolation.t/0","type":"type"},{"doc":"An AST node representing a literal valueProperties* `:value` - the value * `:directives` - directives associated with this literal value","ref":"Surface.AST.Literal.html","title":"Surface.AST.Literal","type":"module"},{"doc":"","ref":"Surface.AST.Literal.html#t:t/0","title":"Surface.AST.Literal.t/0","type":"type"},{"doc":"An AST node representing a macro componentProperties* `:module` - the component module * `:attributes` - the specified attributes * `:directives` - any directives to be applied to this macro * `:body` - the macro body * `:meta` - compilation meta data * `:debug` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.MacroComponent.html","title":"Surface.AST.MacroComponent","type":"module"},{"doc":"","ref":"Surface.AST.MacroComponent.html#t:t/0","title":"Surface.AST.MacroComponent.t/0","type":"type"},{"doc":"A container for metadata about compilation.Properties* `:line` - the line from the source code where the parent was extracted * `:module` - the component module (e.g. `Surface.Components.LivePatch`) * `:node_alias` - the alias used inside the source code (e.g. `LivePatch`) * `:file` - the file from which the source was extracted * `:caller` - a Macro.Env struct representing the caller","ref":"Surface.AST.Meta.html","title":"Surface.AST.Meta","type":"module"},{"doc":"","ref":"Surface.AST.Meta.html#quoted_caller_cid/1","title":"Surface.AST.Meta.quoted_caller_cid/1","type":"function"},{"doc":"","ref":"Surface.AST.Meta.html#t:t/0","title":"Surface.AST.Meta.t/0","type":"type"},{"doc":"An AST node representing a &lt;#slot /&gt; elementProperties* `:name` - the slot name * `:index` - the index of the slotable entry assigned to this slot * `:default` - a list of AST nodes representing the default content for this slot * `:args` - either an atom or a quoted expression representing arguments for this slot * `:meta` - compilation meta data * `:directives` - directives associated with this slot","ref":"Surface.AST.Slot.html","title":"Surface.AST.Slot","type":"module"},{"doc":"","ref":"Surface.AST.Slot.html#t:t/0","title":"Surface.AST.Slot.t/0","type":"type"},{"doc":"An AST node representing a standard HTML tagProperties* `:module` - the component module * `:type` - the type of component (i.e. Surface.LiveComponent vs Surface.Component) * `:slot` - the name of the slot that this component is for * `:let` - the bindings for this template * `:props` - the props for this component * `:directives` - any directives to be applied to this tag * `:children` - the tag children * `:meta` - compilation meta data * `:debug` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.SlotableComponent.html","title":"Surface.AST.SlotableComponent","type":"module"},{"doc":"","ref":"Surface.AST.SlotableComponent.html#t:t/0","title":"Surface.AST.SlotableComponent.t/0","type":"type"},{"doc":"An AST node representing a generic sub-block.Properties* `:name` - name of the block * `:expression` - the expression passed to block * `:children` - children AST nodes * `:meta` - compile meta * `:debug` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.SubBlock.html","title":"Surface.AST.SubBlock","type":"module"},{"doc":"","ref":"Surface.AST.SubBlock.html#t:t/0","title":"Surface.AST.SubBlock.t/0","type":"type"},{"doc":"An AST node representing a standard HTML tagProperties* `:element` - the element name * `:attributes` - the attributes for this tag * `:directives` - any directives to be applied to this tag * `:children` - the tag children * `:meta` - compilation meta data * `:debug` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.Tag.html","title":"Surface.AST.Tag","type":"module"},{"doc":"","ref":"Surface.AST.Tag.html#t:t/0","title":"Surface.AST.Tag.t/0","type":"type"},{"doc":"An AST node representing a &lt;#template&gt; element. This is used to provide content for slotsProperties* `:name` - the template name * `:let` - the bindings for this template * `:children` - the template children * `:meta` - compilation meta data * `:debug` - keyword list indicating when debug information should be printed during compilation * `:directives` - directives associated with this template","ref":"Surface.AST.Template.html","title":"Surface.AST.Template","type":"module"},{"doc":"","ref":"Surface.AST.Template.html#t:t/0","title":"Surface.AST.Template.t/0","type":"type"},{"doc":"An AST node representing a void (empty) HTML tagProperties* `:element` - the element name * `:attributes` - the attributes for this tag * `:directives` - any directives to be applied to this tag * `:meta` - compilation meta data * `:debug` - keyword list indicating when debug information should be printed during compilation","ref":"Surface.AST.VoidTag.html","title":"Surface.AST.VoidTag","type":"module"},{"doc":"","ref":"Surface.AST.VoidTag.html#t:t/0","title":"Surface.AST.VoidTag.t/0","type":"type"},{"doc":"A behaviour to provide additional information about the catalogue.Optional for local catalogues. Usually required if you want to share your components as a library.","ref":"Surface.Catalogue.html","title":"Surface.Catalogue","type":"behaviour"},{"doc":"Returns a keyword list of config options to be used by the catalogue tool.Available options:head_css - CSS related content to be added to the &lt;head&gt;...&lt;/head&gt; section of each example or playground.head_js - JS related content to be added to the &lt;head&gt;...&lt;/head&gt; section of each example or playground.example - A keyword list of options to be applied for all examples in in the catalogue.playground - A keyword list of options to be applied for all playgrounds in in the catalogue.","ref":"Surface.Catalogue.html#c:config/0","title":"Surface.Catalogue.config/0","type":"callback"},{"doc":"Loads a text file as module attribute so you can inject its content directly in head_css or head_js config options.Useful to avoid depending on external css or js code. The path should be relative to the caller's folder.Available options:as - the name of the module attribute to be generated.","ref":"Surface.Catalogue.html#load_asset/2","title":"Surface.Catalogue.load_asset/2","type":"macro"},{"doc":"Experimental module that provides conveniences for manipulating data in Examples and Playgrounds.Provide wrappers around built-in functions like get_in/2 and update_in/3 using a shorter syntax for accessors.Accessor Mapping[_]: Access.all/0[fun]: Access.filter(fun)[index]: Access.at(index) (Shorthand for [index: i])[index: i]: Access.at(i)[key: k]: Access.key(k)[first..last]: Surface.Catalogue.Data.slice(first..last)ExampleData.get(props.lists[_].cards[&amp; &amp;1.id == &quot;Card_1&quot;].tags[-1].name)The code above will be translated to:get_in(props, [:lists, Access.all, :cards, Access.filter(&amp; &amp;1.id == &quot;Card_1&quot;), :tags, Access.at(-1), :name])","ref":"Surface.Catalogue.Data.html","title":"Surface.Catalogue.Data","type":"module"},{"doc":"Appends an item to a list in the given nested structure.","ref":"Surface.Catalogue.Data.html#append/2","title":"Surface.Catalogue.Data.append/2","type":"macro"},{"doc":"Deletes an item from the given nested structure.","ref":"Surface.Catalogue.Data.html#delete/1","title":"Surface.Catalogue.Data.delete/1","type":"macro"},{"doc":"Gets a value from the given nested structure.A wrapper around get_in/2","ref":"Surface.Catalogue.Data.html#get/1","title":"Surface.Catalogue.Data.get/1","type":"macro"},{"doc":"Gets an existing value from the given nested structure.Raises an error if none or more than one value is found.","ref":"Surface.Catalogue.Data.html#get!/1","title":"Surface.Catalogue.Data.get!/1","type":"macro"},{"doc":"Gets a value and updates a given nested structure.A wrapper around get_and_update_in/3","ref":"Surface.Catalogue.Data.html#get_and_update/2","title":"Surface.Catalogue.Data.get_and_update/2","type":"macro"},{"doc":"Inserts an item into a list in the given nested structure.","ref":"Surface.Catalogue.Data.html#insert_at/3","title":"Surface.Catalogue.Data.insert_at/3","type":"macro"},{"doc":"Pops a item from the given nested structure.A wrapper around pop_in/2","ref":"Surface.Catalogue.Data.html#pop/1","title":"Surface.Catalogue.Data.pop/1","type":"macro"},{"doc":"Prepends an item to a list in the given nested structure.","ref":"Surface.Catalogue.Data.html#prepend/2","title":"Surface.Catalogue.Data.prepend/2","type":"macro"},{"doc":"Generates a short ramdom id.","ref":"Surface.Catalogue.Data.html#random_id/1","title":"Surface.Catalogue.Data.random_id/1","type":"function"},{"doc":"","ref":"Surface.Catalogue.Data.html#slice/1","title":"Surface.Catalogue.Data.slice/1","type":"function"},{"doc":"","ref":"Surface.Catalogue.Data.html#unnest/1","title":"Surface.Catalogue.Data.unnest/1","type":"function"},{"doc":"Updates an item in the given nested structure.A wrapper around update_in/2","ref":"Surface.Catalogue.Data.html#update/2","title":"Surface.Catalogue.Data.update/2","type":"macro"},{"doc":"Experimental LiveView to create examples for catalogue tools.OptionsBesides the buit-in options provided by the LiveView itself, an Example also provides the following options:subject - Required. The target component of the Example.height - Required. The height of the Example.catalogue - Optional. A module that implements the Surface.Catalogue providing additional information to the catalogue tool. Usually required if you want to share your components as a library.body - Optional. Sets/overrides the attributes of the the Example's body tag. Useful to set a different background or padding.title - Optional. The title of the example.direction - Optional. Defines how the example + code boxes should be displayed. Available values are &quot;horizontal&quot; or &quot;vertical&quot;. Default is &quot;horizontal&quot; (side-by-side).code_perc - Optional. When the direction is &quot;horizontal&quot;, defines the percentage of the total width that the code box should take. Default is 50. Note: This configuration has no effect when direction is &quot;vertical&quot;.","ref":"Surface.Catalogue.Example.html","title":"Surface.Catalogue.Example","type":"module"},{"doc":"Experimental LiveView to create Playgrounds for catalogue tools.OptionsBesides the buit-in options provided by the LiveView itself, a Playground also provides the following options:subject - Required. The target component of the Playground.height - Required. The initial height of the Playground.catalogue - Optional. A module that implements the Surface.Catalogue providing additional information to the catalogue tool. Usually required if you want to share your components as a library.body - Optional. Sets/overrides the attributes of the Playground's body tag. Useful to set a different background or padding.","ref":"Surface.Catalogue.Playground.html","title":"Surface.Catalogue.Playground","type":"module"}]